stages:
    - build
    - verify-build
    - deploy
    - verify-deploy
    
variables:
  TARGET: target
  PACKAGE_NAME: "java-tomcat-maven-example"

# Java-Maven Build
compile-package:
  stage: build
  script:
    - mvn -B clean test-compile install package -DskipTests=true
  artifacts:
    expire_in: 1 week
    paths:
      - $TARGET
  tags:
    - tomcat-vm

# Java-Maven unit test Build
unit-test:
  stage: verify-build
  script:
    - mvn -B clean test-compile install package -DskipTests=false
  dependencies: []
  tags:
    - tomcat-vm

deploy-tomcat-vm:
  stage: deploy
  script:
    - mvn -B clean test-compile install package -DskipTests=true
    - Stop-Service -Name "tomcat9"
    - copy-item ${CI_PROJECT_DIR}/${TARGET}/${PACKAGE_NAME}.war "C:\Program Files (x86)\Apache Software Foundation\Tomcat 9.0\webapps" -Force
    - Start-Service -Name "tomcat9"
  dependencies: []
  tags:
    - tomcat-vm

validate-deploy:
  stage: verify-deploy
  script:
    - ./tomcat-verify.ps1
  dependencies: []
  tags:
    - tomcat-vm